<template>
  <div class="row justify-center bg-info q-py-lg">
    <div
      class="col-xl-6 col-lg-6 col-md-8 col-sm-12 col-xs-12 text-center text-bold text-white q-pt-md"
      :class="$q.platform.is.desktop ? 'text-h4' : 'text-h5'"
      v-text="'PLANOS DISPONÍVEIS'"
    />

    <q-separator color="transparent" />

    <div class="col-xl-8 col-lg-9 col-md-11 col-sm-12 col-xs-12 row justify-center q-pt-lg">
      <div
        v-for="item in items"
        :key="item.id"
        :class="cardSize"
      >
        <q-card
          class="zoom row justify-center content-start"
          :class="{ 'fit': !$q.screen.sm && !$q.screen.xs }"
        >
          <div v-if="item.recommended">
            <div class="ribbon">
              <span :style="{ backgroundColor: item.color }">
                PROMOÇÃO
              </span>
            </div>
          </div>

          <q-card-section
            class="col-12 fit text-center text-grey"
            style="max-height: 175px"
          >
            <div class="text-subtitle2 q-pt-xs">
              {{ item.title }}
            </div>

            <div
              class="text-h4 q-pt-xs"
              :style="{ color: item.color }"
            >
              {{ item.price / item.installments | formatValue }}
            </div>

            <div class="text-subtitle2 text-grey q-pt-xs">
              {{ item.subtitle }}
            </div>

            <!-- eslint-disable vue/no-v-html -->
            <div
              class="text-caption text-grey q-pb-sm"
              v-html="item.description"
            />
          </q-card-section>

          <q-separator inset />

          <q-card-section
            class="col-12 fit"
            :style="`max-height: ${maxHeight}`"
          >
            <q-list>
              <q-item
                v-for="(benefit, index) in item.benefits"
                :key="index"
                dense
              >
                <q-item-section side>
                  <q-icon
                    :name="benefit.icon"
                    size="18px"
                  />
                </q-item-section>

                <q-item-section>
                  <q-item-label
                    class="text-weight-bold"
                    lines="1"
                    caption
                  >
                    {{ benefit.label }}
                  </q-item-label>
                </q-item-section>
              </q-item>
            </q-list>
          </q-card-section>

          <q-card-actions class="col-12 bg-white q-pa-lg">
            <q-btn
              class="full-width"
              :style="{ backgroundColor: item.color }"
              :label="item.buttonLabel"
              text-color="white"
              unelevated
              rounded
              @click="$router.push({ name: 'checkout', params: { planId: item.id } })"
            />
          </q-card-actions>
        </q-card>
      </div>
    </div>

    <q-separator color="transparent" />

    <div
      v-if="items.statistics && items.statistics.length"
      class="col-xl-6 col-lg-6 col-md-10 col-sm-10 col-xs-12 row justify-center q-pt-xl q-pb-lg"
    >
      <div
        v-for="item in items.statistics"
        :key="item.id"
        class="col-xl-4 col-lg-4 col-md-4 col-sm-8 col-xs-11 q-pa-md"
      >
        <q-item>
          <q-item-section
            avatar
            top
          >
            <q-icon
              :name="item.iconName"
              :color="item.iconColor"
              :size="item.iconSize"
            />
          </q-item-section>

          <q-item-section class="text-subtitle1 q-pl-md">
            <q-item-label
              :class="`text-${item.textColor} no-margin`"
              lines="1"
            >
              {{ item.label }}
            </q-item-label>

            <q-item-label
              :class="`text-weight-bold text-${item.textColor} no-margin`"
              lines="1"
            >
              <h3 class="no-margin">
                <number
                  easing="Power4.easeOut"
                  :to="item.value"
                  :duration="2"
                  :delay="1"
                  :from="0"
                />
              </h3>
            </q-item-label>

            <q-item-label
              :class="`text-${item.textColor} no-margin`"
              lines="3"
            >
              {{ item.sublabel }}
            </q-item-label>
          </q-item-section>
        </q-item>
      </div>
    </div>
  </div>
</template>

<script>
import { formatToBRL } from 'brazilian-values'
import _ from 'lodash'

export default {
  name: 'Plans',
  filters: {
    formatValue (value) {
      return formatToBRL(value)
    }
  },
  props: {
    items: {
      type: Array,
      default: () => ([])
    }
  },
  computed: {
    cardSize () {
      let classes

      switch (this.items.length) {
        case 1:
          classes = 'col-xl-5 col-lg-5 col-md-5 col-sm-8 col-xs-11'
          break

        default:
          classes = 'col-xl-4 col-lg-4 col-md-4 col-sm-8 col-xs-11'
          break
      }

      return classes + ' q-pa-md'
    },
    maxHeight () {
      const max = _(this.items).map('benefits').map(_.size).max()
      const height = `${(max * 32) + 32}px`

      return height
    }
  }
}
</script>
